var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, Input, ViewChild, ElementRef, Renderer, HostListener } from '@angular/core';
import { WindowRef } from '../window-ref/window-ref.service';
import { OverlayContentComponent } from './overlay-content.component';
var OverlayComponent = (function () {
    function OverlayComponent(windowRef, renderer) {
        this.windowRef = windowRef;
        this.renderer = renderer;
    }
    OverlayComponent.prototype.ngOnInit = function () {
    };
    OverlayComponent.prototype.addContent = function (options) {
        this.overlayOptions = options;
        if (!this.overlayOptions.html && this.overlayOptions.component) {
            this.overlayContent.addContent(this.overlayOptions);
        }
        this.adjustOverlayPosition();
    };
    OverlayComponent.prototype.onWinResize = function () {
        this.adjustOverlayPosition();
    };
    OverlayComponent.prototype.adjustOverlayPosition = function () {
        var _this = this;
        setTimeout(function () {
            var rect = _this.overlayBody.nativeElement.getBoundingClientRect();
            var elmHeight = rect.height;
            var elmWidth = rect.width;
            var winHeight = _this.windowRef.innerHeight;
            var winWidth = _this.windowRef.innerWidth;
            var left = (winWidth - elmWidth) / 2;
            var top = (winHeight - elmHeight) / 2;
            _this.renderer.setElementStyle(_this.overlayBody.nativeElement, 'top', top + "px");
            _this.renderer.setElementStyle(_this.overlayBody.nativeElement, 'left', left + "px");
        }, 0);
    };
    return OverlayComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", Object)
], OverlayComponent.prototype, "overlayOptions", void 0);
__decorate([
    ViewChild('overlayBody'),
    __metadata("design:type", ElementRef)
], OverlayComponent.prototype, "overlayBody", void 0);
__decorate([
    ViewChild(OverlayContentComponent),
    __metadata("design:type", OverlayContentComponent)
], OverlayComponent.prototype, "overlayContent", void 0);
__decorate([
    HostListener('window:resize', []),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], OverlayComponent.prototype, "onWinResize", null);
OverlayComponent = __decorate([
    Component({
        selector: 're-overlay',
        template: "\n    <div #overlayBody class=\"overlay-body\" style=\"z-index: 1050;top:300px;left: 200px;\">\n      <div *ngIf=\"overlayOptions?.html\" [innerHTML]=\"overlayOptions.html\"></div>\n      <re-overlay-content #overlayContent style=\"display: none;\"></re-overlay-content>\n    </div>\n    <re-modal-backdrop [isOpen]=\"true\" [modalOptions]=\"overlayOptions\"></re-modal-backdrop>\n  ",
        styles: ["\n    .overlay-body{position:fixed}\n  "],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [WindowRef, Renderer])
], OverlayComponent);
export { OverlayComponent };
//# sourceMappingURL=overlay.component.js.map